import os
import requests
from urllib.parse import quote

# Constants
BASE_API_URL = 'https://api.nemg.me/v2/tiktok/tikwm.json'
DOWNLOAD_DIR = '/sdcard/Tiktok No Logo - Minh Phú Coder'
PHONE_NUMBER_DIR = 'Zalo : 0987278064'

# Ensure download directory exists
os.makedirs(DOWNLOAD_DIR, exist_ok=True)

def download_tiktok_video(url_video):
    # Construct API URL
    api_url = f'{BASE_API_URL}?video={quote(url_video)}'
    
    # Make request to API
    response = requests.get(api_url)
    if response.status_code == 200:
        # Save video to download directory
        video_file_path = os.path.join(DOWNLOAD_DIR, 'video.mp4')
        with open(video_file_path, 'wb') as f:
            f.write(response.content)
        
        # Create Zalo directory
        zalo_dir = os.path.join(DOWNLOAD_DIR, PHONE_NUMBER_DIR)
        os.makedirs(zalo_dir, exist_ok=True)
        
        return video_file_path
    else:
        return None

# Override print function to handle TikTok URL input
def print(*args, **kwargs):
    if len(args) > 0 and isinstance(args[0], str) and '{tiktok}' in args[0]:
        url_video = input("Nhập link video TikTok: ")
        if url_video.startswith('https://www.tiktok.com/') or url_video.startswith('https://m.tiktok.com/'):
            video_path = download_tiktok_video(url_video)
            if video_path:
                print(f"Video đã được tải xuống và lưu tại: {video_path}")
            else:
                print("Đã xảy ra lỗi trong quá trình tải video.")
        else:
            print("Đây không phải là đường dẫn hợp lệ của TikTok.")
    else:
        builtins.print(*args, **kwargs)
        